<?php
/**
 * @package CG template switcher Module
 * @version 1.0.14 : 2019 May
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2019 ConseilGouz. All Rights Reserved.
 * @author ConseilGouz 
 * 1.0.14 : AutoSwitch
 */
defined('_JEXEC') or die;

if (!JPluginHelper::isEnabled('system', 'cgstyle')) {
	JFactory::getApplication()->enqueueMessage(JText::_('CG_ACTIVATE'),'error');
	return false;
}
$document 		= JFactory::getDocument();
$modulefield	= ''.JURI::base(true).'/modules/mod_cg_template_switcher/';

$document->addStyleSheet($modulefield .'lib/fancybox/jquery.fancybox.css');
$document->addScript($modulefield .'lib/fancybox/jquery.fancybox.pack.js');
$document->addStyleDeclaration($params->get('css','')); 

JLoader::register('ModCGTemplateSwitcherHelper', __DIR__ . '/helper.php');
$templates =  ModCGTemplateSwitcherHelper::getTemplates($params);

$templates_js = array();
if ($params->get('showpreview', 'true') == 'true') {
	foreach ($templates->images as $template => $image) { 
		$arr['width'] =  $image->width;
		$arr['height'] = $image->height;
		$arr['src'] = $image->src;
		$arr['preview'] = $image->preview;
		$templates_js[$template] = $arr;
	}
}
$document->addScriptOptions('mod_cg_template_switcher', 
	array('cookie_duration' => $params->get('cookie_duration', 0),'showpreview' => $params->get('showpreview', 'true'),
		  'autoswitch' => $params->get('autoswitch', 'false'),
		  'noimage' => JText::_('NOIMAGE'),'templates' => $templates_js));
$document->addScript($modulefield .'js/init.js');

require_once(JModuleHelper::getLayoutPath($module->module));

?>